"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Dropzone = void 0;
var elements_1 = require("payload/components/elements");
var react_1 = __importDefault(require("react"));
var react_i18next_1 = require("react-i18next");
var react_jss_1 = require("react-jss");
var handleDragOver = function (e) {
    e.preventDefault();
    e.stopPropagation();
};
var baseClass = "dropzone";
var Dropzone = function (_a) {
    var onChange = _a.onChange, className = _a.className, mimeTypes = _a.mimeTypes, fileName = _a.fileName;
    var dropRef = react_1.default.useRef(null);
    var _b = react_1.default.useState(false), dragging = _b[0], setDragging = _b[1];
    var inputRef = react_1.default.useRef(null);
    var t = (0, react_i18next_1.useTranslation)(["upload", "general"]).t;
    var styles = useStyles();
    var handlePaste = react_1.default.useCallback(function (e) {
        var _a;
        e.preventDefault();
        e.stopPropagation();
        if (((_a = e.clipboardData) === null || _a === void 0 ? void 0 : _a.files) && e.clipboardData.files.length > 0) {
            onChange(e.clipboardData.files);
        }
    }, [onChange]);
    var handleDragEnter = react_1.default.useCallback(function (e) {
        e.preventDefault();
        e.stopPropagation();
        setDragging(true);
    }, []);
    var handleDragLeave = react_1.default.useCallback(function (e) {
        e.preventDefault();
        e.stopPropagation();
        setDragging(false);
    }, []);
    var handleDrop = react_1.default.useCallback(function (e) {
        var _a;
        e.preventDefault();
        e.stopPropagation();
        setDragging(false);
        if (((_a = e.dataTransfer) === null || _a === void 0 ? void 0 : _a.files) && e.dataTransfer.files.length > 0) {
            onChange(e.dataTransfer.files);
            setDragging(false);
            e.dataTransfer.clearData();
        }
    }, [onChange]);
    var handleFileSelection = react_1.default.useCallback(function (e) {
        if (e.target.files && e.target.files.length > 0) {
            onChange(e.target.files);
        }
    }, [onChange]);
    react_1.default.useEffect(function () {
        var div = dropRef.current;
        if (div) {
            div.addEventListener("dragenter", handleDragEnter);
            div.addEventListener("dragleave", handleDragLeave);
            div.addEventListener("dragover", handleDragOver);
            div.addEventListener("drop", handleDrop);
            div.addEventListener("paste", handlePaste);
            return function () {
                div.removeEventListener("dragenter", handleDragEnter);
                div.removeEventListener("dragleave", handleDragLeave);
                div.removeEventListener("dragover", handleDragOver);
                div.removeEventListener("drop", handleDrop);
                div.removeEventListener("paste", handlePaste);
            };
        }
        return function () { return null; };
    }, [handleDragEnter, handleDragLeave, handleDrop, handlePaste]);
    var classes = [baseClass, className, dragging ? "dragging" : "", styles.dropzoneImport]
        .filter(Boolean)
        .join(" ");
    return (react_1.default.createElement("div", { ref: dropRef, className: classes },
        react_1.default.createElement(elements_1.Button, { size: "small", buttonStyle: "secondary", onClick: function () {
                var _a;
                (_a = inputRef.current) === null || _a === void 0 ? void 0 : _a.click();
            }, className: "".concat(baseClass, "__file-button") }, t("selectFile")),
        react_1.default.createElement("input", { ref: inputRef, type: "file", accept: mimeTypes === null || mimeTypes === void 0 ? void 0 : mimeTypes.join(","), onChange: handleFileSelection, className: "".concat(baseClass, "__hidden-input") }),
        react_1.default.createElement("p", { className: "".concat(baseClass, "__label") }, fileName || "or drop file here")));
};
exports.Dropzone = Dropzone;
var useStyles = (0, react_jss_1.createUseStyles)({
    dropzoneImport: {
        height: "clamp(100px,100vh,200px)",
        margin: "auto",
    },
});
//# sourceMappingURL=index.js.map