"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExportExpand = void 0;
var elements_1 = require("payload/components/elements");
var react_1 = __importStar(require("react"));
var react_animate_height_1 = __importDefault(require("react-animate-height"));
var react_select_1 = __importDefault(require("react-select"));
var react_toastify_1 = require("react-toastify");
var papaparse_1 = __importDefault(require("papaparse"));
var utilities_1 = require("payload/components/utilities");
var flattenFields_1 = __importDefault(require("../../utils/flattenFields"));
var link_1 = __importDefault(require("../link"));
var multiSelect_1 = require("../multiSelect");
var select_1 = require("../select");
var react_jss_1 = require("react-jss");
var csv_1 = require("../../utils/csv");
var options = [
    { label: "JSON", value: "json" },
    { label: "CSV", value: "csv" },
];
function ExportExpand(_a) {
    var _this = this;
    var open = _a.open, collection = _a.collection;
    var ref = (0, react_1.useRef)(null);
    var _b = (0, react_1.useState)(options[0]), format = _b[0], setFormat = _b[1];
    var fields = (0, react_1.useMemo)(createFlattenedFields(collection), [collection]);
    var _c = (0, react_1.useState)(fields), selectedFields = _c[0], setSelectedFields = _c[1];
    var styles = useStyles();
    var config = (0, utilities_1.useConfig)();
    var locale = (0, utilities_1.useLocale)();
    if (!(config && config.serverURL)) {
        return null;
    }
    var api = config.routes.api, serverURL = config.serverURL;
    var handleExport = function () { return __awaiter(_this, void 0, void 0, function () {
        var search, data, href, download, date, lang, docs, _a, columns, flattenedData, csv, blob, filteredData, err_1;
        var _b, _c, _d;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    if (selectedFields.length === 0) {
                        return [2 /*return*/, react_toastify_1.toast.error("Please select fields to export")];
                    }
                    search = new URLSearchParams(window === null || window === void 0 ? void 0 : window.location.toString());
                    search.set("limit", "0"); // removes the limit
                    locale.code && search.set("locale", locale.code);
                    _e.label = 1;
                case 1:
                    _e.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, fetch("".concat(serverURL).concat(api, "/").concat(collection.slug, "?").concat(search.toString()), {
                            method: "GET",
                            headers: {
                                "Content-type": "application/json",
                            },
                            credentials: "include",
                        }).then(function (res) { return res.json(); })];
                case 2:
                    data = (_e.sent());
                    href = "";
                    download = "";
                    date = new Date().toISOString().replace(":", "");
                    lang = locale.code ? "_".concat(locale.code) : "";
                    docs = data.docs;
                    if (format.value === "csv") {
                        _a = (0, csv_1.getCSVColumnNamesAndFlattendedData)(docs, selectedFields === null || selectedFields === void 0 ? void 0 : selectedFields.map(function (o) { return o.value; })), columns = _a[0], flattenedData = _a[1];
                        csv = papaparse_1.default.unparse(flattenedData, { columns: columns });
                        blob = new Blob([csv], { type: "text/csv;charset=utf-8" });
                        href = URL.createObjectURL(blob);
                        download = "Export_".concat(collection.slug).concat(lang, "_").concat(date, ".csv");
                    }
                    if (format.value === "json") {
                        filteredData = selectedFields.length === fields.length
                            ? docs
                            : docs.map(function (doc) {
                                return selectedFields
                                    .map(function (o) { return o.value; })
                                    .reduce(function (o, k) {
                                    o[k] = doc[k];
                                    return o;
                                }, {});
                            });
                        href = "data:text/json;charset=utf-8,".concat(encodeURIComponent(JSON.stringify(filteredData)));
                        download = "Export_".concat(collection.slug).concat(lang, "_").concat(date, ".json");
                    }
                    (_b = ref.current) === null || _b === void 0 ? void 0 : _b.setAttribute("href", href);
                    (_c = ref.current) === null || _c === void 0 ? void 0 : _c.setAttribute("download", download);
                    (_d = ref.current) === null || _d === void 0 ? void 0 : _d.click();
                    return [3 /*break*/, 4];
                case 3:
                    err_1 = _e.sent();
                    react_toastify_1.toast.error("Failed to fetch data");
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    }); };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(react_animate_height_1.default, { height: open ? "auto" : 0 },
            react_1.default.createElement("div", { className: "card" },
                react_1.default.createElement("h5", { className: "title" }, "Export"),
                react_1.default.createElement("div", { className: styles.cardContent },
                    react_1.default.createElement("div", null,
                        react_1.default.createElement("label", { className: "field-label", htmlFor: "format" }, "Output format"),
                        react_1.default.createElement(react_select_1.default, { required: true, isSearchable: false, styles: select_1.reactSelectStyle, options: options, name: "format", defaultValue: options[0], value: format, onChange: function (val) { return setFormat(val); } })),
                    react_1.default.createElement("div", null,
                        react_1.default.createElement("label", { className: "field-label", htmlFor: "fields" }, "Fields"),
                        react_1.default.createElement(multiSelect_1.MultiSelect, { title: "Fields", options: fields, selected: selectedFields, setSelected: setSelectedFields })),
                    react_1.default.createElement(elements_1.Button, { onClick: handleExport, className: styles.exportButton }, "Export"))),
            react_1.default.createElement(link_1.default, { ref: ref, className: styles.hidden, hidden: true })),
        react_1.default.createElement(react_toastify_1.ToastContainer, { position: "bottom-center" })));
}
exports.ExportExpand = ExportExpand;
exports.default = ExportExpand;
var useStyles = (0, react_jss_1.createUseStyles)({
    cardContent: {
        display: "grid",
        gridTemplateColumns: "repeat(auto-fit, minmax(250px, 1fr))",
        gap: "var(--base)",
        width: "100%",
        flexWrap: "wrap",
    },
    hidden: {
        visibility: "hidden",
    },
    exportButton: {
        height: "4rem",
        marginTop: "auto",
        marginBottom: "6px",
    },
});
function createFlattenedFields(collection) {
    return function () {
        return (0, flattenFields_1.default)(collection.fields).map(function (f) { return ({
            label: "".concat(typeof f.label === "string" ? f.label : f.name),
            value: "".concat(f.name),
        }); });
    };
}
//# sourceMappingURL=ExportExpand.js.map