import React, { Dispatch, SetStateAction } from "react";
import ReactSelect from "react-select";
interface Props extends React.ComponentProps<typeof ReactSelect> {
    options: Option[];
    selected: Option[];
    setSelected: Dispatch<SetStateAction<any>>;
    title: string;
    hide?: boolean;
    initialAction?: () => void;
}
export type Option = {
    value: number | string;
    label: string;
};
export declare const selectAllOption: {
    value: string;
    label: string;
};
export declare const MultiSelect: React.ForwardRefExoticComponent<Pick<Props, "form" | "title" | "className" | "autoFocus" | "name" | "placeholder" | "required" | "selected" | "value" | "defaultValue" | "id" | "tabIndex" | "aria-errormessage" | "aria-invalid" | "aria-label" | "aria-labelledby" | "aria-live" | "onFocus" | "onBlur" | "onChange" | "onKeyDown" | "key" | "loadingMessage" | "noOptionsMessage" | "hide" | "ariaLiveMessages" | "backspaceRemovesValue" | "blurInputOnSelect" | "captureMenuScroll" | "classNamePrefix" | "classNames" | "closeMenuOnSelect" | "closeMenuOnScroll" | "components" | "controlShouldRenderValue" | "delimiter" | "escapeClearsValue" | "filterOption" | "formatGroupLabel" | "formatOptionLabel" | "getOptionLabel" | "getOptionValue" | "hideSelectedOptions" | "inputValue" | "inputId" | "instanceId" | "isClearable" | "isDisabled" | "isLoading" | "isOptionDisabled" | "isOptionSelected" | "isMulti" | "isRtl" | "isSearchable" | "minMenuHeight" | "maxMenuHeight" | "menuIsOpen" | "menuPlacement" | "menuPosition" | "menuPortalTarget" | "menuShouldBlockScroll" | "menuShouldScrollIntoView" | "onInputChange" | "onMenuOpen" | "onMenuClose" | "onMenuScrollToTop" | "onMenuScrollToBottom" | "openMenuOnFocus" | "openMenuOnClick" | "options" | "pageSize" | "screenReaderStatus" | "styles" | "theme" | "tabSelectsValue" | "unstyled" | "setSelected" | "initialAction" | "defaultInputValue" | "defaultMenuIsOpen"> & React.RefAttributes<any>>;
export {};
