"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MultiSelect = exports.selectAllOption = void 0;
var react_1 = __importStar(require("react"));
var react_select_1 = __importDefault(require("react-select"));
var animated_1 = __importDefault(require("react-select/animated"));
var select_1 = require("../select");
var animate = (0, animated_1.default)();
/* Advanced Dropdown Select Menu using React select
 * Inspired by https://stackoverflow.com/a/61250357/20007391 and
 * added typing.
 *
 * For more information about the react-select API, options, and
 * customization, see https://react-select.com/home
 *
 * This component is just the select box. Options are passed in from
 * the parent and the parent maintains the state of the object for
 * callbacks and function handling. */
exports.selectAllOption = { value: "*", label: "Select All" };
exports.MultiSelect = react_1.default.forwardRef(function (_a, ref) {
    // For component "memory"
    var title = _a.title, selected = _a.selected, setSelected = _a.setSelected, options = _a.options, hide = _a.hide, initialAction = _a.initialAction, rest = __rest(_a, ["title", "selected", "setSelected", "options", "hide", "initialAction"]);
    var valueRef = (0, react_1.useRef)(selected);
    valueRef.current = selected;
    var isSelectAllSelected = function () { return valueRef.current.length === options.length; }; // && options.length > 1;
    var isOptionSelected = function (option, selectValue) {
        return valueRef.current.some(function (_a) {
            var value = _a.value;
            return value === option.value;
        }) || isSelectAllSelected();
    };
    // const getOptions = () => (isSelectAllSelected() ? [] : [selectAllOption, ...options]);
    var getOptions = function () { return (options.length > 1 ? __spreadArray([exports.selectAllOption], options, true) : __spreadArray([], options, true)); };
    var getValue = function () { return (isSelectAllSelected() ? [exports.selectAllOption] : selected); };
    var handleSelect = function (newValue, actionMeta) {
        var action = actionMeta.action, option = actionMeta.option, removedValue = actionMeta.removedValue;
        // Reassigning for typing. Unknown by default
        var opt = option;
        var removed = removedValue;
        if (action === "select-option" && opt.value === exports.selectAllOption.value) {
            setSelected(options);
        }
        else if ((action === "deselect-option" && opt.value === exports.selectAllOption.value) ||
            (action === "remove-value" && removed.value === exports.selectAllOption.value)) {
            setSelected([]);
        }
        else if (actionMeta.action === "deselect-option" && isSelectAllSelected()) {
            setSelected(options.filter(function (_a) {
                var value = _a.value;
                return value !== opt.value;
            }));
        }
        else {
            setSelected(newValue || []);
        }
        //
    };
    (0, react_1.useEffect)(function () {
        initialAction === null || initialAction === void 0 ? void 0 : initialAction();
    }, []);
    return (react_1.default.createElement(react_select_1.default, __assign({ ref: ref }, rest, { animate: animate, 
        // @ts-ignore
        isOptionSelected: isOptionSelected, closeMenuOnSelect: false, 
        // defaultValue={selectAllOption} // Should default to select all option
        value: getValue(), isMulti: true, placeholder: title, options: getOptions(), onChange: handleSelect, hideSelectedOptions: hide !== null && hide !== void 0 ? hide : false, instanceId: title, id: title, styles: select_1.reactSelectStyle })));
});
//# sourceMappingURL=index.js.map