"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getCSVColumnNamesAndFlattendedData = exports.getCSVColumnNames = void 0;
var flat_1 = require("./flat");
function getCSVColumnNames(data, prefix) {
    if (prefix === void 0) { prefix = ""; }
    var columns = [];
    for (var key in data) {
        if (typeof data[key] === "object" && !Array.isArray(data[key])) {
            columns = columns.concat(getCSVColumnNames(data[key], "".concat(prefix).concat(key, ".")));
        }
        else {
            data[key].length > 0 && columns.push("".concat(prefix).concat(key));
        }
    }
    return columns;
}
exports.getCSVColumnNames = getCSVColumnNames;
function getCSVColumnNamesAndFlattendedData(data, selectedFields) {
    var columns = [];
    var flat = [];
    data.forEach(function (obj) {
        if (selectedFields && !selectedFields.includes(Object.keys(obj)[0]))
            return;
        var flattenedField = (0, flat_1.flatten)(obj);
        flat.push(flattenedField);
        columns = columns.concat(getCSVColumnNames(flattenedField));
    });
    return [Array.from(new Set(columns)), flat];
}
exports.getCSVColumnNamesAndFlattendedData = getCSVColumnNamesAndFlattendedData;
//# sourceMappingURL=csv.js.map