"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.flattenFields = void 0;
var types_1 = require("payload/types");
/**
 * Flattens a collection's fields into a single array of fields, as long
 * as the fields do not affect data.
 *
 * @param fields
 * @param keepPresentationalFields if true, will skip flattening fields that are presentational only
 */
var flattenFields = function (fields, keepPresentationalFields) {
    return fields.reduce(function (fieldsToUse, field) {
        if ((0, types_1.fieldAffectsData)(field) || (keepPresentationalFields && (0, types_1.fieldIsPresentationalOnly)(field))) {
            return __spreadArray(__spreadArray([], fieldsToUse, true), [field], false);
        }
        if ((0, types_1.fieldHasSubFields)(field)) {
            return __spreadArray(__spreadArray([], fieldsToUse, true), (0, exports.flattenFields)(field.fields, keepPresentationalFields), true);
        }
        if (field.type === "tabs") {
            return __spreadArray(__spreadArray([], fieldsToUse, true), field.tabs.reduce(function (tabFields, tab) {
                return __spreadArray(__spreadArray([], tabFields, true), ((0, types_1.tabHasName)(tab)
                    ? [__assign(__assign({}, tab), { type: "tab" })]
                    : (0, exports.flattenFields)(tab.fields, keepPresentationalFields)), true);
            }, []), true);
        }
        return fieldsToUse;
    }, []);
};
exports.flattenFields = flattenFields;
exports.default = exports.flattenFields;
//# sourceMappingURL=flattenFields.js.map