"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var templates_1 = require("payload/components/templates");
var utilities_1 = require("payload/components/utilities");
var utilities_2 = require("payload/utilities");
var react_1 = __importStar(require("react"));
var react_i18next_1 = require("react-i18next");
var react_toastify_1 = require("react-toastify");
var ImportForm_1 = require("../components/import/ImportForm");
var react_jss_1 = require("react-jss");
var useRedirect_1 = require("../utils/useRedirect");
function ViewWrapper(props) {
    var i18n = (0, react_i18next_1.useTranslation)("general").i18n;
    var paths = window.location.pathname.split("/");
    var collectionSlug = paths[3];
    var config = (0, utilities_1.useConfig)();
    var styles = useStyles();
    var redirect = (0, useRedirect_1.useRedirect)();
    if (!props.canAccessAdmin || !props.user) {
        var route = "".concat(config.routes.admin, "/login?redirect=/collections/").concat(collectionSlug, "/import");
        redirect(route);
        return null;
    }
    var hasPermissions = (0, react_1.useMemo)(function () {
        if (!config.custom.importExportPluginConfig.canImport)
            return true;
        return config.custom.importExportPluginConfig.canImport(props.user);
    }, [props.user]);
    return (react_1.default.createElement(templates_1.DefaultTemplate, null,
        react_1.default.createElement(utilities_1.Meta, { title: (0, utilities_2.getTranslation)(collectionSlug.charAt(0).toUpperCase() + collectionSlug.slice(1), i18n) }),
        !hasPermissions ? (react_1.default.createElement("main", { className: styles.main },
            react_1.default.createElement("h1", null,
                "Forbidden ",
                react_1.default.createElement("h4", null, "You are not allowed to import Data")))) : (react_1.default.createElement(ImportForm_1.ImportForm, null)),
        react_1.default.createElement(react_toastify_1.ToastContainer, { position: "bottom-center", autoClose: 30000 })));
}
exports.default = ViewWrapper;
var useStyles = (0, react_jss_1.createUseStyles)({
    main: {
        display: "grid",
        placeItems: "center",
        height: "80vh",
        textAlign: "center",
    },
});
//# sourceMappingURL=ViewWrapper.js.map